Rem Resample.CSC v1.2 from AntiPoetics.com
Rem Copyright  February 2009 James Aswell

Dim PaperSize As Boolean, AntiAlias As Boolean, ImageAlign As Long
Dim newWidth As Long, newHeight As Long, newDPIx As Long, newDPIy As Long
Dim UpsampleWidth As Boolean, UpsampleHeight As Boolean
Dim DownsampleWidth As Boolean, DownsampleHeight As Boolean
Dim ClrMode As Long, Clr1 As Long, Clr2 As Long, Clr3 As Long, Clr4 As Long

'#########################################################
'User Settings:
'#########################################################

'New Width and Height values:
newWidth = 1024
newHeight = 768

'New DPI values:
newDPIx = 300
newDPIy = 300

'Resizing:
    'Note: to change only the DPI without resizing, set the
    'Upsample and Downsample value pairs to False.

    'Upsample if either image dimension is smaller than new size
    UpsampleWidth = True
    UpsampleHeight = True

    'Downsample if either image dimension is larger than new size
    DownsampleWidth = True
    DownsampleHeight = True

    'Perform anti-aliasing if the image is resampled
    AntiAlias = True

'Paper Size:
    'Crop or expand paper size as needed to fit new dimensions
    PaperSize = True

    'Image alignment after change in paper size
    ImageAlign = 4
        '0 = Top, Left
        '1 = Top, Center
        '2 = Top, Right
        '3 = Center, Left
        '4 = Center, Center
        '5 = Center, Right
        '6 = Bottom, Left
        '7 = Bottom, Center
        '8 = Bottom, Right

    'Color mode used to specify the paper color.  Note: The actual image
    'color mode will be preserved regardless of what you specify.  Also,
    'colors specified below MUST be valid for this color mode.
    ClrMode = 5
        '3 = CMYK
        '5 = RGB
        '8 = Black and White
        '9 = Grayscale

    'Paper color component values (based on the above: RGB, CMYK, etc...)
    Clr1 = 255
    Clr2 = 255
    Clr3 = 255
    Clr4 = 0

'#########################################################
'End of user settings
'#########################################################

WithObject "CorelPhotoPaint.Automation.13"

    If .GetDocumentCount() > 0 Then

        Dim iWidth As Long, iHeight As Long, x As Long, y As Long
        iWidth = .GetDocumentWidth()
        iHeight = .GetDocumentHeight()
    
        If iHeight < iWidth Then 'landscape
            Dim ImageHeight2 As Long
            ImageHeight2 = Int(((newWidth / iWidth) * iHeight))
            If ImageHeight2 > newHeight Then
                x = Int(((newHeight / iHeight) * iWidth))
                y = newHeight
            Else
                x = newWidth
                y = Int(((newWidth / iWidth) * iHeight))
            End If
        Else 'square or portrait
            x = Int(((newHeight / iHeight) * iWidth))
            y = newHeight
        End If

        'Resample Operations
        If Not ((UpsampleWidth = True And iWidth < x) Or \\
            (UpsampleHeight = True And iHeight < y) Or \\
            (DownsampleWidth = True And iWidth > x) Or \\
            (DownsampleHeight = True And iHeight > y)) Then

            'no resampling
            x = iWidth
            y = iHeight
        End If

        'set image to new size and/or DPI
        .ImageResample x, y, newDPIx, newDPIy, AntiAlias
    
        'Paper Operations
        If PaperSize = True Then
            Dim offsetX As Long, offsetY As Long

            Select Case ImageAlign
                Case 0, 1, 2
                    offsetY = (newHeight - y)       'V Top
                Case 3, 4, 5
                    offsetY = (newHeight - y) / 2   'V Center
                Case 6, 7, 8
                    offsetY = 0                     'V Bottom
            End Select

            Select Case ImageAlign
                Case 0, 3, 6
                    offsetX = 0                     'H Left
                Case 1, 4, 7
                    offsetX = (newWidth - x) / 2    'H Center
                Case 2, 5, 8
                    offsetX = newWidth - x          'H Right
            End Select

            .ImagePapersize newWidth, newHeight, offsetX, -offsetY, \\
                ClrMode, Clr1, Clr2, Clr3, Clr4
        End If
    End If
End WithObject
